SystemOrganization addCategory: #'People-spfa-format'!


PackageInfo subclass: #SPFAFormatInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'People-spfa-format'!

SPFAFormatInfo class
	instanceVariableNames: ''!


!String methodsFor: '*People-spfa-format' stamp: 'spfa 3/7/2003 18:37'!
asB64

	"'Hi there!!' asB64"

	| ss | 

	ss _ ReadWriteStream on: (String new).
	ss nextPutAll: self.

	^ (Base64MimeConverter mimeEncode: ss) contents.
! !

!String methodsFor: '*People-spfa-format' stamp: 'spfa 1/8/2003 15:22'!
asBoldText

	^ (Text fromString: self) 
		addAttribute: (TextEmphasis bold)! !

!String methodsFor: '*People-spfa-format' stamp: 'spfa 1/7/2003 21:55'!
asCodeText

	^ (Text fromString: self) 
		addAttribute: (TextDoIt evalString: self);
		addAttribute: (TextColor blue)! !

!String methodsFor: '*People-spfa-format' stamp: 'spfa 1/7/2003 21:55'!
asEvalText: someCode

	^ (Text fromString: self) 
		addAttribute: (TextDoIt evalString: someCode);
		addAttribute: (TextColor blue)! !

!String methodsFor: '*People-spfa-format' stamp: 'spfa 1/7/2003 21:55'!
asExplicitEvalText: someCode

	^ (self asEvalText: someCode),
	((Text fromString: ' (code)') 
		addAttribute: (TextDoIt  
							evalString: '''', someCode asB64, ''' openB64InWorkspace');
		addAttribute: (TextColor magenta))! !

!String methodsFor: '*People-spfa-format' stamp: 'spfa 1/8/2003 18:11'!
asMGraphDocText

	| txt |

	txt _ self asText.

	(MGraph classes collect: [:ea | ea asString])
		do: [:ea | | c |
				(c _ txt findString: ea startingAt: 1)
					isZero ifFalse: 
					[txt addAttribute: (TextDoIt evalString: (ea, ' showDocumentation'))
						  from: c to: (c + ea size).
					 txt addAttribute: (TextColor magenta) from: c to: (c + ea size).]].

	^ txt! !

!String methodsFor: '*People-spfa-format' stamp: 'spfa 3/7/2003 18:23'!
asTextThatSend: aSelector toClass: aClass 

	| scl ssel |

	scl _ aClass asString.
	ssel _ aSelector asString.

	^ (self asEvalText: scl, ' perform:#', ssel),
	((Text fromString: ' (code)') 
		addAttribute: (TextDoIt evalString: 'Browser fullOnClass: ', scl, ' class selector: #', ssel);
		addAttribute: (TextColor magenta))! !

!String methodsFor: '*People-spfa-format' stamp: 'spfa 4/28/2004 00:45'!
fromB64

	"'SGkgVGhlcmUh' fromB64"

	| ss |

	ss _ ReadWriteStream on: (String new).
	ss nextPutAll: self.

 	^ (Base64MimeConverter mimeDecodeToChars: ss) contents ! !

!String methodsFor: '*People-spfa-format' stamp: 'spfa 5/24/2004 15:05'!
openB64InWorkspace

	"'SGkgVGhlcmUh' openB64InWorkspace"

	self fromB64 displayWithLabel: 'code'! !

!SPFAFormatInfo methodsFor: 'as yet unclassified' stamp: 'spfa 11/6/2003 19:09'!
prerequisitePackages
	"These are the names of DVS packages that get loaded before the main change set"
	^#('People-spfa-files')! !

!String methodsFor: '*People-spfa-format' stamp: 'spfa 5/17/2004 20:29'!
sformat: objectOrList

	"replace the keywords in self with the corresponding representation of the objects in objectOrList"

	"	keywords:
	
	%s		generic replacement
	%q		surround by simple quotes
	%Q		surround by double quotes
	%C		capitalize
	%U		uppercase
	%l		lowercase
	%Y		yes/no (for Boolean)
	%F		file reference
	%E		file reference for Emacs
	%d		as duration (in seconds)

	%pN 	with precision N
	%hN 	hexadecimal with N figures
		
		examples:
		
	'%s -W -r %s -o %F' sformat: {'srconv' . 44100 . 'hi joe.wav'}
	'a duration of %d' sformat: 36125
	'243 is hexa %h2' sformat: 243
	'24356 is hexa %h4' sformat: 24356
	'answer %Y/%Y' sformat: {true . false}
	"
	
	| str bits args |

	str _ self copyReplaceAll: '_rt' with: (String cr, String tab).
	str _ str copyReplaceAll: '_t' with: String tab.  
	str _ str copyReplaceAll: '_r' with: String cr.

	bits _ (' ', str copyReplaceAll: '%%' with: '--tmpschmilblickhere--') findTokens: '%'.
	str _ bits first allButFirst.

	(objectOrList isCollection & objectOrList isString not)
		ifTrue: [args _ objectOrList]
		ifFalse: [args _ {objectOrList}].

	bits allButFirst with: args do: [:s :o |
		str _ str,
		(s first caseOf: {
		 [$s] -> [o asString, s allButFirst].
		 [$q] -> [o asString surroundedBySingleQuotes, s allButFirst].
		 [$Q] -> [o asString surroundedByDoubleQuotes, s allButFirst].
		 [$C] -> [o asString capitalized, s allButFirst].
		 [$U] -> [o asString translateToUppercase, s allButFirst].
		 [$l] -> [o asString translateToLowercase, s allButFirst].
		 [$Y] -> [(o ifTrue: ['yes'] ifFalse: ['no']), s allButFirst].
 		 [$F] -> [(FileReference wrapFileName: o asString), s allButFirst].
 		 [$E] -> [(FileReference wrapFileNameForEmacs: o asString), s allButFirst].
 		 [$/] -> [(FileReference codeFileNameForEmacs: o asString), s allButFirst].
		 [$d] -> [(o * 1000) milliSeconds asString, s allButFirst].	
		 [$p] -> [(o precision: s second asString asNumber) asString, (s allButFirst: 2)].
		 [$h] -> [(o hexString: s second asString asNumber) asString, (s allButFirst: 2)].	
		}
		otherwise: [self error: 'illegal format code'])].

	^ str copyReplaceAll: '--tmpschmilblickhere--' with: '%'.

	! !

!TranscriptStream methodsFor: '*People-spfa-format' stamp: 'spfa 1/26/2004 18:15'!
sformat: anArray into: aString

	self show: (aString sformat: anArray)! !
