SystemOrganization addCategory: #'People-spfa-utils'!


Workspace subclass: #MGraphWorkspace
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'People-spfa-utils'!

BorderedMorph subclass: #MouseInputArea
	instanceVariableNames: 'balloonText messageSend'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'People-spfa-utils'!

MouseInputArea subclass: #DropReporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'People-spfa-utils'!

PluggableTextMorph subclass: #SPFAPluggableTextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'People-spfa-utils'!

TextMorphEditor subclass: #SPFATextMorphEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'People-spfa-utils'!

TextMorphForEditView subclass: #SPFATextMorphForEditView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'People-spfa-utils'!

MouseInputArea subclass: #SensitiveArea
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'People-spfa-utils'!

MGraphWorkspace class
	instanceVariableNames: ''!

MouseInputArea class
	instanceVariableNames: ''!

DropReporter class
	instanceVariableNames: ''!

SPFAPluggableTextMorph class
	instanceVariableNames: ''!

SPFATextMorphEditor class
	instanceVariableNames: ''!

SPFATextMorphForEditView class
	instanceVariableNames: ''!

SensitiveArea class
	instanceVariableNames: ''!


!DropReporter commentStamp: 'spfa 3/11/2004 09:54' prior: 0!
usage:

	(DropReporter sendMorphTo: receiver via: selector) openInWorld

any morph dropped in the DropReporter is sent to receiver via selector, then the morph is rejected to its previous position and the DropReporter disappear (to make it permanent, double-click inside: the border becomes green, and more than one morph can be dropped).

receiver can be nil, in which case selector is sent to the morph itself.

example:

	(DropReporter sendMorphTo: nil via: #collapse) openInWorld!

!MGraphWorkspace commentStamp: 'spfa 5/16/2003 15:40' prior: 0!
a Workspace in which dropped Morphs are inlined in the edited Text.

at present inlining is restricted to MGraphElementMorphs for convenience, but this can be changed easily by simply removing method #wantsDroppedMorph:event:inMorph:!

!MouseInputArea commentStamp: 'spfa 3/11/2004 09:35' prior: 0!
A labelled rectangular area triggering a MessageSend upon specific mouse activity.

The area may disappear after action (it is not "permanent") or even disappear after a few seconds whatever happens (it is then "temporary")

This abstract class does not implement event handling. See subclasses.

!

!SPFAPluggableTextMorph commentStamp: 'spfa 5/16/2003 15:48' prior: 0!
A component for MGraphWorkspace!

!SPFATextMorphEditor commentStamp: 'spfa 5/16/2003 15:48' prior: 0!
A component for MGraphWorkspace!

!SPFATextMorphForEditView commentStamp: 'spfa 5/16/2003 15:48' prior: 0!
A component for MGraphWorkspace!

!SensitiveArea commentStamp: 'spfa 3/11/2004 09:58' prior: 0!
This area evaluate its MessageSend upon mouseEnter!

!LineSegment methodsFor: '*People-spfa-utils' stamp: 'spfa 6/7/2003 17:59'!
+ aPoint

	^ self class from: (start + aPoint) to: (end + aPoint)! !

!LineSegment methodsFor: '*People-spfa-utils' stamp: 'spfa 6/7/2003 17:59'!
- aPoint

	^ self class from: (start - aPoint) to: (end - aPoint)! !

!MGraphWorkspace methodsFor: 'as yet unclassified' stamp: 'spfa 5/14/2003 15:02'!
acceptDroppedMorphsWording

	^ self acceptsDroppingMorphForReference
		ifTrue: ['<yes>inline dropped morphs']
		ifFalse: ['<no>inline dropped morphs']
! !

!DropReporter methodsFor: 'event handling' stamp: 'spfa 6/12/2003 11:16'!
acceptDroppingMorph: dropee event: evt 

	| ms |

	dropee wasReported.
	dropee rejectDropMorphEvent: evt.
	dropee wasRejected.

	ms _ messageSend.
	ms receiver ifNil: [ms receiver: dropee].

	(ms valueWithArguments: {dropee})
		ifNil: [^ self]. 	"if receiver sent nil back, it didn't like the dropee. so stay alive and wait for the next one"

	(self hasProperty: #permanent)
		ifFalse: [self delete]! !

!MGraphWorkspace methodsFor: 'as yet unclassified' stamp: 'spfa 5/28/2003 19:06'!
acceptDroppingMorph: dropee event: evt inMorph: targetMorph 

	dropee isVignette
		ifTrue: [ targetMorph addVignette: dropee]
		ifFalse:
		[
			dropee textAnchorType: #inline.
			targetMorph correctSelectionWithString: (' ' asText, (Text string: (String value: 1) attribute: (TextAnchor new anchoredMorph: dropee)), (' ' asText)).

			targetMorph forceTextRefresh.
		].

	^ true 
! !

!RunArray methodsFor: '*People-spfa-utils' stamp: 'spfa 5/6/2003 15:22'!
accumulatedRuns

	| d |

	d _ 0.

	^ runs collect: [:r | d _ d + r]! !

!RunArray methodsFor: '*People-spfa-utils' stamp: 'spfa 5/6/2003 15:24'!
accumulatedRunsAndValuesDo: aBlock

	^ self accumulatedRuns with: values do: aBlock.! !

!MenuMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 4/28/2003 14:00'!
add: aString getter: aSelector setter: bSelector

	self add: aString getter: aSelector setter: bSelector target: defaultTarget! !

!MenuMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 4/6/2004 09:22'!
add: aString getter: aSelector setter: bSelector queryPrompt: qString 

	^ self add: aString getter: aSelector setter: bSelector queryPrompt: qString target: defaultTarget then: #yourself! !

!MenuMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 4/15/2004 10:39'!
add: aString getter: aSelector setter: bSelector queryPrompt: qString target: anObject

	^ self add: aString getter: aSelector setter: bSelector queryPrompt: qString target: anObject then: #yourself! !

!MenuMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 4/9/2004 15:20'!
add: aString getter: aSelector setter: bSelector queryPrompt: qString target: anObject then: cSelector

	self addFromMessage: (Message 
								selector: #makeGetterSetterWordingFrom: 
								arguments: {aString -> (MessageSend 
															receiver: anObject 
															selector: aSelector)})
		 target: self
		 selector: #queryArgumentFor:inBehalfOf:withString:initialAnswer:then:
		 argumentList: {bSelector . anObject . qString . aSelector . cSelector}! !

!MenuMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 4/28/2003 14:21'!
add: aString getter: aSelector setter: bSelector target: anObject

	self add: aString getter: aSelector setter: bSelector target: anObject then: #yourself! !

!MenuMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 4/6/2004 10:51'!
add: aString getter: aSelector setter: bSelector target: anObject then: cSelector

	^ self add: aString getter: aSelector setter: bSelector queryPrompt: aString target: anObject then: cSelector! !

!MenuMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 3/13/2004 22:42'!
add: aString toggleForProperty: aSymbol
	
	self addFromMessageSend: 
			(((MessageSend receiver: defaultTarget
			  				   selector: #hasProperty:
							   arguments: {aSymbol})	
				withMetaSelector: #yesNoString)
				withMetaSelector: #, arguments: {aString})
		  target: defaultTarget
		  selector: #toggleProperty: 
		  argumentList: {aSymbol}! !

!MenuMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 3/13/2004 22:42'!
add: aString toggleForProperty: aSymbol then: bSymbol

	self addFromMessageSend: 
			(((MessageSend receiver: defaultTarget
			  				   selector: #hasProperty:
							   arguments: {aSymbol})	
				withMetaSelector: #yesNoString)
				withMetaSelector: #, arguments: {aString})
		  target: defaultTarget
		  selector: #toggleProperty:then:
		  argumentList: {aSymbol . bSymbol}.! !

!MenuMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 4/5/2004 15:22'!
add: aListOfAssociations valuesForProperty: aSymbol 

	^ self add: aListOfAssociations valuesForProperty: aSymbol then: #yourself! !

!MenuMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 3/13/2004 22:45'!
add: aListOfAssociations valuesForProperty: aSymbol then: bSymbol

	aListOfAssociations do: [:ea |
			
	self addFromMessageSend: 
			((((MessageSend receiver: defaultTarget
			  				   selector: #valueOfProperty:
							   arguments: {aSymbol})	
				withMetaSelector: #= arguments: {ea value})				
				withMetaSelector: #yesNoString)
				withMetaSelector: #, arguments: {ea key})
		  target: defaultTarget
		  selector: #setProperty:toValue:then: 
		  argumentList: {aSymbol . ea value . bSymbol}
		
	]! !

!MenuMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 3/12/2004 19:00'!
addFromMessage: wordingMessage target: target selector: aSymbol argumentList: argList
	"Append a menu item with the given label. If the item is selected, it will send the given selector to the target object with the given arguments. If the selector takes one more argument than the number of arguments in the given list, then the triggering event is supplied as as the last argument.  In this variant, the wording of the menu item is obtained by sending the wordingMessage to the target,  Answer the item added."

	| item |
	item _ UpdatingMenuItemMorph new
		target: target;
		selector: aSymbol;
		wordingProvider: target wordingSelector: wordingMessage selector;
		wordingArgument: wordingMessage arguments first;
		arguments: argList asArray.
	self addMorphBack: item.
	^ item
! !

!MenuMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 3/13/2004 21:45'!
addFromMessageSend: wordingMessageSend target: target selector: aSymbol argumentList: argList
	"Append a menu item with the given label. If the item is selected, it will send the given selector to the target object with the given arguments. If the selector takes one more argument than the number of arguments in the given list, then the triggering event is supplied as as the last argument.  In this variant, the wording of the menu item is obtained by sending the wordingMessage to the target,  Answer the item added."

	| item |
	item _ UpdatingMenuItemMorph new
		target: target;
		selector: aSymbol;
		wordingProvider: wordingMessageSend wordingSelector: #value;
		arguments: argList asArray.
	self addMorphBack: item.
	^ item
! !

!MenuMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 3/13/2004 11:26'!
addLabel: aString

	self add: aString asString target: nil selector: #isNil! !

!MenuMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 3/13/2004 11:22'!
addLabel: label watching: aMessageSend
	
	aMessageSend isSymbol ifTrue:
	[^ self addLabel: label watching: (MessageSend receiver: defaultTarget 
														selector: aMessageSend)].
	
	^ self addUpdatingService: 
		(UpdatingServiceEntry watching: aMessageSend label: label)
! !

!MenuMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 4/6/2004 11:12'!
addLabel: label watching: aMessageSend action: bMessageSend
	
	aMessageSend isSymbol ifTrue:
	[^ self addLabel: label watching: (MessageSend receiver: defaultTarget 
														selector: aMessageSend)].
	
	^ self addUpdatingService: 
		(UpdatingServiceEntry watching: aMessageSend label: label action: bMessageSend)
! !

!MenuMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 3/13/2004 11:23'!
addLabelWatching: aMessageSend
	
	^ self addLabel: '%s' watching: aMessageSend! !

!MenuMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 3/12/2004 15:25'!
addService: aService

	self addService: aService for: nil! !

!MenuMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 3/12/2004 15:53'!
addServices: aListOfServices

	aListOfServices do: [:service | self addService: service]! !

!MenuMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 6/4/2004 16:12'!
addSubclassesOf: aMorphClass

"
	add an item for registered subclasses of aMorphClass, allowing to open an instance in Hand.

	the registration is done on the class side through:
	#idString	-> when not nil (a String), make an item with that label
	#instanceTypes  -> when not-nil (a Dictionary), make a submenu with keys as labels and values as nativity selectors
	#partsBinSubmenuHeader -> when present (returns a String) make a submenu for all subclasses. 
"

	aMorphClass subclasses do: [:ea |

	(ea idString notNil 
		and: [(ea class includesSelector: #partsBinSubmenuHeader) not])
	ifTrue: 
	[
		| itypes |
		(itypes _ ea instanceTypes)
		ifNil: [self add: (ea idString) 
						 target: ea 
						 selector: #asNewMorphInHand]
		ifNotNil: [self add: (ea idString, ' ') subMenu: (ea instanceTypesMenu)].
		self addSubclassesOf: ea
	]
	ifFalse:
	[
		(ea class includesSelector: #partsBinSubmenuHeader) 
	 	ifTrue: 
	 	[
			ea partsBinSubmenuHeader
			ifNotNil: [	| m |
						m _ MenuMorph new.
						ea idString 
						ifNotNil: [m add: (ea idString) 
									 target: ea 
						 			 selector: #asNewMorphInHand].
  		 				m addSubclassesOf: ea.
						self add: (ea partsBinSubmenuHeader, ' ') subMenu: m]
		]
		ifFalse: [self addSubclassesOf: ea]
	]]! !

!MenuMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 1/11/2003 20:44'!
addToggleForProperty: aSymbol

	self add: aSymbol asString toggleForProperty: aSymbol! !

!MenuMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 3/13/2004 10:07'!
addUpdatingService: aService
	
	^ self addUpdatingService: aService for: nil
! !

!MenuMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 3/13/2004 10:12'!
addUpdatingService: aService for: serviceUser
	"Append a menu item with the given service. If the item is selected, it will perform the given service.
	The item label is updated when the service is an UpdatingServiceEntry"

	self addUpdating: #label target: aService selector: aService requestSelector argumentList: {serviceUser}
! !

!SPFAPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'spfa 5/28/2003 18:20'!
addVignette: dropee

 	| ws old |

	self isABookPage 
		ifTrue: [ ws _ self]
		ifFalse: [ws _ owner]. "in a SystemWindow, then"

	old _ ws findA: MGraphVignette.
	old ifNotNil: [old delete].
	dropee bottomLeft: ws topLeft.
	ws addMorph: dropee! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 6/17/2003 14:16'!
allFontsBecome: aFont

	self allMorphsDo: [:m |
		(m respondsTo: #font:) 
			ifTrue: [m font: aFont]].

	self changed
! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 5/19/2003 14:34'!
allFontsToDefault

	self allFontsBecome: TextStyle defaultFont.
	self changed

! !

!MessageSend methodsFor: '*People-spfa-utils' stamp: 'spfa 4/13/2004 14:47'!
altPrintString

	^ receiver printString, '>>', selector printString! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 2/3/2004 13:38'!
asButton

	| label |

	label _ (FillInTheBlank request: 'button label:' initialAnswer: self buttonName) 
		whenEmpty: [^ self].

	(MenuMorph new add: label	target: self action: #openInHand)
		stayUp: true; openInHand! !

!Class methodsFor: '*People-spfa-utils' stamp: 'spfa 6/4/2004 16:12'!
asNewMorphInHand

	^ self new asMorph openInHand! !

!String methodsFor: '*People-spfa-utils' stamp: 'spfa 11/6/2003 22:59'!
asNumberOrZero

	"properly reads a float number missing an initial 0, as '.4'"

	^ [self asNumber] 
		on: Error 
		do: [
				(self allButFirst, ' ') asNumber. "if it fails, accept the failure !!"
				('0', self) asNumber "else maybe this will do, as in .2 -> 0.2"
			]	! !

!BlockContext methodsFor: '*People-spfa-utils' stamp: 'spfa 2/12/2004 10:06'!
asSetterString

	^ (DialectStream dialect: #ST80
						contents: [:strm | self decompile printOn: strm indent: 0])
			asString! !

!Object methodsFor: '*People-spfa-utils' stamp: 'spfa 2/12/2004 10:08'!
asSetterString

	^ self asString! !

!Point class methodsFor: '*People-spfa-utils' stamp: 'spfa 5/21/2004 10:14'!
atOrigin

	^ 0@0! !

!MouseInputArea methodsFor: 'private' stamp: 'spfa 3/11/2004 09:15'!
balloonText

	^ balloonText! !

!MouseInputArea methodsFor: 'accessing' stamp: 'spfa 3/11/2004 09:15'!
balloonText: aText

	balloonText _ aText! !

!MouseInputArea methodsFor: 'options' stamp: 'spfa 5/31/2004 22:11'!
bePermanent

	self getProperty: #permanent.
	self borderColor: Color green muchDarker
	! !

!MouseInputArea methodsFor: 'options' stamp: 'spfa 3/11/2004 09:15'!
beSmall

	self 
		 extent: 80@50;
		borderWidth: 1.
		
	! !

!MouseInputArea methodsFor: 'options' stamp: 'spfa 5/31/2004 22:11'!
beTemporary

	self getProperty: #temporary.
	
	! !

!MGraphWorkspace methodsFor: 'as yet unclassified' stamp: 'spfa 5/16/2003 14:53'!
bindEmbeddedMorphs
	
	^ self bindEmbeddedMorphsIn: self contents asText.
! !

!MGraphWorkspace methodsFor: 'as yet unclassified' stamp: 'spfa 5/16/2003 14:53'!
bindEmbeddedMorphsIn: aText

	| txt |
	
	txt _ aText.

	aText embeddedMorphsIndexes reverse do: [:p |
		| morph bindingName index |
		index _ p first.
		morph _ p second.
		bindingName _ (morph externalName translateToLowercase, morph identityHash printString) asIdentifier: false.
		(self bindingOf: bindingName) value: morph.
		txt _ txt copyReplaceFrom: index to: index 
					with: (' ', (bindingName asText), ' ')].

	^ txt! !

!DropReporter class methodsFor: 'utilities' stamp: 'spfa 6/12/2003 14:59'!
buttonMaker

	^ (self sendMorphTo: nil via: #asButton) bePermanent label: '-> button'! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 1/26/2004 20:24'!
buttonName

	^ self knownName ifNil: [self name]! !

!Point methodsFor: '*People-spfa-utils' stamp: 'spfa 4/2/2004 20:04'!
closeTo: aPoint

	^ (x closeTo: aPoint x) and: [y closeTo: aPoint y]! !

!Number methodsFor: '*People-spfa-utils' stamp: 'spfa 3/17/2003 23:02'!
closestMultipleOf: anInteger

	^ (self / anInteger) rounded * anInteger! !

!MGraphWorkspace class methodsFor: 'as yet unclassified' stamp: 'spfa 5/16/2003 19:12'!
color

	^ Color steelBlue lighter lighter! !

!SPFATextMorphEditor methodsFor: 'as yet unclassified' stamp: 'spfa 5/16/2003 14:41'!
compileSelectionAsBlock
	"Treat the current selection as an expression; evaluate it and return the result"
	| stream result rcvr ctxt |
	self lineSelectAndEmptyCheck: [^ ''].

	stream _ ReadWriteStream on: (String new: (stopBlock stringIndex) - (startBlock stringIndex) + 2).
	stream nextPutAll: '[[ '.
	stream nextPutAll: self selectionAsEvaluableString.
	stream nextPutAll: ' ] on: Error do: [ :ex | ex ]]'.
	stream reset.

	(model respondsTo: #doItReceiver) 
		ifTrue: [FakeClassPool adopt: model selectedClass.  "Include model pool vars if any"
				rcvr _ model doItReceiver.
				ctxt _ model doItContext]
		ifFalse: [rcvr _ ctxt _ nil].
	result _ [
		rcvr class evaluatorClass new 
			evaluate: stream
			in: ctxt
			to: rcvr
			notifying: self
			ifFail: [FakeClassPool adopt: nil. ^ #failedDoit]
	] 
		on: OutOfScopeNotification 
		do: [ :ex | ex resume: true].
	FakeClassPool adopt: nil.
	^ result! !

!Text methodsFor: '*People-spfa-utils' stamp: 'spfa 5/6/2003 15:39'!
copyReplaceEmbeddedMorphsThrough: aSelector

	| txt |

	txt _ self.

	self embeddedMorphsIndexes reverse do: [:p |
		txt _ txt copyReplaceFrom: p first to: p first with: (p second perform: aSelector)].

	^ txt! !

!String methodsFor: '*People-spfa-utils' stamp: 'spfa 5/24/2004 15:03'!
displayWithLabel: aString 

	self asText displayWithLabel: aString ! !

!Text methodsFor: '*People-spfa-utils' stamp: 'spfa 5/24/2004 15:02'!
displayWithLabel: aString 

	self displayWithLabel: aString onColor: Color tan darker.
! !

!Text methodsFor: '*People-spfa-utils' stamp: 'spfa 5/24/2004 15:00'!
displayWithLabel: aString onColor: aColor
	"Open up a system window with the receiver as its contents, with the given title"

	| w |

	w _ SystemWindow labelled: aString.
	w paneColor: aColor.
	w addMorph: (PluggableTextMorph on: self text: #asText accept: nil) frame: (0@0 corner: 1@1).

	w openInWorld
! !

!DropReporter methodsFor: 'event handling' stamp: 'spfa 6/5/2003 00:37'!
doubleClick: evt

	self bePermanent.
! !

!MGraphWorkspace methodsFor: 'as yet unclassified' stamp: 'spfa 5/12/2003 16:25'!
embeddedInMorphicWindowLabeled: labelString
	| window |
	window _ (SystemWindow labelled: labelString) model: self.
	window addMorph: (SPFAPluggableTextMorph on: self text: #contents accept: #acceptContents:
			readSelection: nil menu: #codePaneMenu:shifted:)
		frame: (0@0 corner: 1@1).
	^ window! !

!Text methodsFor: '*People-spfa-utils' stamp: 'spfa 5/16/2003 14:13'!
embeddedMorphsFrom: anIndex to: anotherIndex

	^ self embeddedMorphsIndexes select: [:p |
		| index |
		index _ p first.
		(index >= anIndex and: [index <= anotherIndex])]
	 	thenCollect: [:p | p second].
! !

!Text methodsFor: '*People-spfa-utils' stamp: 'spfa 5/6/2003 15:32'!
embeddedMorphsIndexes

	| am |
	am _ SortedCollection sortBlock: [:p1 : p2 | p1 first <= p2 first].
	runs accumulatedRunsAndValuesDo: 
	[:i :v |
		v do: [:attr |
				attr anchoredMorph ifNotNil: [am add: {i . attr anchoredMorph}]]].

	^am! !

!String methodsFor: '*People-spfa-utils' stamp: 'spfa 4/1/2003 15:54'!
evaluate

	^ Compiler evaluate: self! !

!SPFAPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'spfa 5/22/2003 17:58'!
findReferenceOfVignette: aVignette

	"used by MGraphWorkspace"

	| v |

	v _ self submorphOfClass: MGraphVignette.
	(v notNil and:
		[v echoes: aVignette])
		ifTrue: [^ model].

	^ super findReferenceOfVignette: aVignette! !

!SystemWindow methodsFor: '*People-spfa-utils' stamp: 'spfa 5/22/2003 16:18'!
findReferenceOfVignette: aVignette

	"used by MGraphWorkspace"

	| v |

	v _ self submorphOfClass: MGraphVignette.
	(v notNil and:
		[v echoes: aVignette])
		ifTrue: [^ model].

	^ super findReferenceOfVignette: aVignette
! !

!TextMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 5/19/2003 14:33'!
font: aFont

	self fontName: aFont name size: aFont pointSize! !

!Number methodsFor: '*People-spfa-utils' stamp: 'spfa 12/2/2003 21:02'!
forceIn: anInterval

	^ (self max: anInterval first) min: anInterval last! !

!SPFAPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'spfa 5/22/2003 16:22'!
forceTextRefresh

	"very weird and clumsy workaround !!!!"

	| carret |

	carret _ self selectionInterval last.
	
	self changeText: (self text, ' ' asText).
	self changeText: (self text copyFrom: 1 to: (self text size - 1 max: 0)).
	self hasUnacceptedEdits: true.

	textMorph editor selectAt: carret+1.
	self scrollSelectionIntoView ifFalse: [scroller changed].
! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 2/20/2004 10:17'!
getCopyButton

	| label |

	label _ (FillInTheBlank request: 'button label:' initialAnswer: self buttonName) 
		ifEmpty: [^ self]; yourself.

	(MenuMorph new add: ('+ ', label) target: self action: #openCopyInHand)
		stayUp: true; openInHand! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 5/31/2004 22:09'!
getProperty: aSymbol

	self setProperty: aSymbol
		  toValue: true
					! !

!Object methodsFor: '*People-spfa-utils' stamp: 'spfa 2/2/2004 20:49'!
getReference

	"create a ghost-like TransferMorph with self as passenger and give it to the Hand"

	^ (TransferMorph withPassenger: self) 
		color: Color transparent;
		extent: self extent;
		addMorph: self imageForm reverse asMorph;
		source: self;
		openInHand! !

!Cursor class methodsFor: '*People-spfa-utils' stamp: 'spfa 3/18/2003 23:22'!
hand

	^(Cursor
			extent: 16@16
			fromArray: #(
		2r0000011011011000
		2r0000100100100100
		2r0000010010010010
		2r0011010010010010
		2r0100110010010010
		2r0101100010010010
		2r1001000000000010
		2r0100000000000010
		2r0010000000000100
		2r0001000000001000
		2r0000100000001000
		2r0000100000010000
		2r0000100000010000
		2r0000100000010000
		2r0000111111110000
		2r0000000000000000)
			offset: 0@0).
! !

!DropReporter methodsFor: 'event handling' stamp: 'spfa 5/8/2003 17:13'!
handlesMouseDown: evt
	^ true! !

!SensitiveArea methodsFor: 'event handling' stamp: 'spfa 3/10/2004 13:31'!
handlesMouseOver: evt

	^ true! !

!Morph class methodsFor: '*People-spfa-utils' stamp: 'spfa 5/23/2003 14:06'!
idString
	"return a string used to identify this morph in a part bin menu, or nil if this morph is not supposed to be available from there"

	^ nil! !

!MGraphWorkspace methodsFor: 'as yet unclassified' stamp: 'spfa 5/14/2003 15:01'!
initialize

	super initialize.
	acceptDroppedMorphs _ true! !

!MouseInputArea methodsFor: 'private' stamp: 'spfa 3/11/2004 09:15'!
initialize

	super initialize.
	self color: (Color white alpha: 0.7);
		 extent: 100@100;
		borderColor: Color red;
		borderWidth: 3.
		
	self setProperty: #creationTime toValue: Time now
	! !

!SPFATextMorphForEditView methodsFor: 'as yet unclassified' stamp: 'spfa 5/14/2003 14:13'!
installEditorToReplace: priorEditor
	"Install an editor for my paragraph.  This constitutes 'hasFocus'.
	If priorEditor is not nil, then initialize the new editor from its state.
	We may want to rework this so it actually uses the prior editor."

	| stateArray |
	priorEditor ifNotNil: [stateArray _ priorEditor stateArray].
	editor _ SPFATextMorphEditor new morph: self.
	editor changeParagraph: self paragraph.
	priorEditor ifNotNil: [editor stateArrayPut: stateArray].
	self selectionChanged.
	^ editor! !

!Object methodsFor: '*People-spfa-utils' stamp: 'spfa 4/10/2003 11:35'!
instanceInfoLine

	"displayed by the instances browser"

	^ self printString! !

!Object methodsFor: '*People-spfa-utils' stamp: 'spfa 4/10/2003 15:09'!
instanceInfoText

	"displayed by the instances browser"

	| txt |

	txt _ ''.

	self isMorph ifTrue:
		[txt _ txt,  'in project: ', (self world ifNil: ['<NONE>']
												ifNotNil: [self world project name]), 
									String cr,
					  'owner: ', self owner asString, String cr].

	^ txt, 'known name: ', self knownName asString! !

!Morph class methodsFor: '*People-spfa-utils' stamp: 'spfa 12/2/2003 15:05'!
instanceTypes
	"return nil or a dictionary providing different instance creation methods (values) associated to their names (keys), so that we can register different types of the morph in a part bin or a menu"

	^ nil! !

!Morph class methodsFor: '*People-spfa-utils' stamp: 'spfa 6/4/2004 16:26'!
instanceTypesMenu

	| m itypes |

	m _ MenuMorph new.
	itypes _ self instanceTypes.

	itypes keysDo:	[:k |
		m add: k 	
			target: (MessageSend receiver: self selector: (itypes at: k))
			selector: #valuePerform:
			argumentList: {#openCopyInHand}.			
			].

	^ m

! !

!Point methodsFor: '*People-spfa-utils' stamp: 'spfa 3/19/2003 14:57'!
isOrigin

	^ self = ( 0@0 )! !

!SPFATextMorphForEditView methodsFor: 'as yet unclassified' stamp: 'spfa 5/16/2003 19:01'!
isPlayfieldForConnectors
	^ true! !

!SPFAPluggableTextMorph methodsFor: 'starbrowser' stamp: 'spfa 2/10/2004 10:58'!
itemActionFor: aVisitor	
	
	^aVisitor doSPFAPTM: self! !

!SPFAPluggableTextMorph methodsFor: 'starbrowser' stamp: 'spfa 2/10/2004 13:01'!
itemLabel

	^ self valueOfProperty: #itemLabel! !

!SPFAPluggableTextMorph methodsFor: 'starbrowser' stamp: 'spfa 2/10/2004 13:01'!
itemLabel: aString

	self setProperty: #itemLabel toValue: aString! !

!MouseInputArea methodsFor: 'accessing' stamp: 'spfa 3/11/2004 09:15'!
label: aString

	self removeAllMorphs.
	self addMorph: ((TextMorph new contents: aString asBoldText) 
						borderWidth: 1;
						margins: 2;
						centered;
						autoFit: true;
						backgroundColor: (Color thistle muchLighter alpha: 0.9); 
						center: self bounds bottomCenter)! !

!SimpleServiceEntry methodsFor: '*People-spfa-utils' stamp: 'spfa 3/13/2004 10:19'!
label: aString
	label _ aString! !

!MenuMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 4/5/2004 16:03'!
makeGetterSetterWordingFrom: anAssociation

	anAssociation key ifEmpty: [^ anAssociation value value asSetterString].

	^ anAssociation key, ': ', anAssociation value value asSetterString! !

!MouseInputArea class methodsFor: 'utilities' stamp: 'spfa 3/11/2004 10:31'!
makeHalo: aRectangle with: anArrayOfAssociations color: aColor

	anArrayOfAssociations 
	with: 
	({	 #bottomRight: -> #topLeft.
	 	 #bottomLeft: -> #topRight.
	      #topRight: -> #bottomLeft.
	 	 #topLeft: -> #bottomRight} first: anArrayOfAssociations size) 
	do: 
	[:assoc :cop |
		(self new)
			beTemporary; beSmall; 
			perform: cop key with: (aRectangle perform: cop value);
			messageSend: assoc value;
			smallLabel: assoc key;
			borderColor: aColor;
			openInWorld]


			
	! !

!DropReporter class methodsFor: 'utilities' stamp: 'spfa 3/11/2004 10:43'!
makeHaloTargetting: aMorph withSelectors: anArrayOfAssociations color: aColor

	self makeHalo: aMorph bounds
		with: (anArrayOfAssociations
				collect: [:a | a key -> (MessageSend
											receiver: aMorph
											selector: a value)])
		color: aColor 


! !

!Magnitude methodsFor: '*People-spfa-utils' stamp: 'spfa 2/22/2003 11:55'!
maxUnlessNil: aMagnitude 

	aMagnitude ifNil: [^ self].
	^ self max: aMagnitude! !

!MouseInputArea methodsFor: 'accessing' stamp: 'spfa 3/11/2004 09:15'!
messageSend: aMessageSend

	messageSend _ aMessageSend! !

!Magnitude methodsFor: '*People-spfa-utils' stamp: 'spfa 2/22/2003 11:54'!
minUnlessNil: aMagnitude 

	aMagnitude ifNil: [^ self].
	^ self min: aMagnitude! !

!Number methodsFor: '*People-spfa-utils' stamp: 'spfa 5/31/2003 15:54'!
mod2Pi

	^ self \\ Float twoPi! !

!Number methodsFor: '*People-spfa-utils' stamp: 'spfa 3/23/2004 14:47'!
modPi

	^ self \\ Float pi! !

!Number methodsFor: '*People-spfa-utils' stamp: 'spfa 12/2/2003 21:29'!
moduleIn: anInterval

	| xt x|

	x _ self.
	xt _ anInterval extent.
	x > anInterval last ifTrue: [xt _ xt negated].
	[anInterval rangeIncludes: x]
		whileFalse: [x _ x + xt].
	^ x 

	! !

!DropReporter methodsFor: 'event handling' stamp: 'spfa 5/8/2003 17:11'!
mouseDown: evt
	"Wait for a double-click"
	evt hand waitForClicksOrDrag: self event: evt.

	^super mouseDown: evt
! !

!SensitiveArea methodsFor: 'event handling' stamp: 'spfa 3/10/2004 21:53'!
mouseEnter: evt

	self flash.
	messageSend value.
	self temporary ifTrue: [0.1 seconds asDelay wait. self delete].
! !

!Morph class methodsFor: '*People-spfa-utils' stamp: 'spfa 5/23/2003 13:51'!
newOpenInHand

	^ self new openInHand! !

!SPFAPluggableTextMorph class methodsFor: 'as yet unclassified' stamp: 'spfa 2/6/2004 15:24'!
newPage

	^ (SPFAPluggableTextMorph on: MGraphWorkspace new
			text: #contents
			accept: #acceptContents:
			readSelection: nil 
			menu: #codePaneMenu:shifted:)
		color: (Color white alpha: 0.9)! !

!MenuItemMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 4/9/2004 14:27'!
noWeakTarget

	"ensure that target is never weakly copied"

	self setProperty: #noWeakTarget toValue:  target
	! !

!MGraphWorkspace methodsFor: 'as yet unclassified' stamp: 'spfa 6/12/2003 10:51'!
openAsMorphLabel: labelString 

	(self embeddedInMorphicWindowLabeled: labelString) openInWorld; 
		setWindowColor:  self class color! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 6/13/2003 11:47'!
openCopyInHand

	self veryDeepCopy openInHand! !

!Text methodsFor: '*People-spfa-utils' stamp: 'spfa 5/6/2003 11:49'!
openInWorkspaceWithTitle: aTitle
	"Open up a workspace with the receiver as its contents, with the given title"

	(Workspace new contents: self) openLabel: aTitle! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 3/11/2004 09:51'!
openNearHand

	(self bottomRight: (self currentHand position - (10@10))) openInWorld! !

!MGraphWorkspace methodsFor: 'as yet unclassified' stamp: 'spfa 5/22/2003 14:53'!
output

	^ (self bindingOf: 'output') value! !

!SPFATextMorphEditor methodsFor: 'as yet unclassified' stamp: 'spfa 5/16/2003 14:21'!
paste
	"Paste the text from the shared buffer over the current selection and 
	redisplay if necessary.  Undoer & Redoer: undoAndReselect."

	self replace: self selectionInterval with: self clipboardText veryDeepCopy and:
		[self selectAt: stopBlock stringIndex].

	self ptm forceTextRefresh.
! !

!Rectangle methodsFor: '*People-spfa-utils' stamp: 'spfa 5/23/2003 15:05'!
preciseCenter
	"Answer the point at the center of the receiver."

	^ (self topLeft + self bottomRight) / 2! !

!Point methodsFor: '*People-spfa-utils' stamp: 'spfa 5/7/2003 14:01'!
preciselyScaleFrom: rect1 to: rect2
	"Produce a point stretched according to the stretch from rect1 to rect2, and do not convert numbers to Integer"
	^ rect2 topLeft + (((x-rect1 left) * rect2 width / rect1 width)
					@ ((y-rect1 top) * rect2 height / rect1 height))! !

!Collection methodsFor: '*People-spfa-utils' stamp: 'spfa 5/21/2004 17:37'!
precision: aNumber
	
	^ self collect: [:ea | ea precision: aNumber]! !

!LineSegment methodsFor: '*People-spfa-utils' stamp: 'spfa 6/7/2003 17:51'!
precision: aNumber

	self from: (start precision: aNumber) to: (end precision: aNumber)! !

!Number methodsFor: '*People-spfa-utils' stamp: 'spfa 1/15/2003 23:26'!
precision: aNumber

	| pten |

	(self isInteger) ifTrue: [^ self].

	pten _ 10 raisedTo: aNumber.
	^ ((pten * self) rounded / pten) asFloat! !

!Object methodsFor: '*People-spfa-utils' stamp: 'spfa 5/21/2004 17:34'!
precision: aNumber

	^ self! !

!Point methodsFor: '*People-spfa-utils' stamp: 'spfa 3/18/2003 21:45'!
precision: anInteger

	^ (self x precision: anInteger) @ (self y precision: anInteger) ! !

!Rectangle methodsFor: '*People-spfa-utils' stamp: 'spfa 3/18/2003 22:42'!
precision: anInteger

	^ (self origin precision: anInteger) corner: (self corner precision: anInteger)
! !

!String methodsFor: '*People-spfa-utils' stamp: 'spfa 6/25/2003 21:36'!
precision: aNumber

	^ self contractTo: aNumber+5! !

!SimpleServiceEntry methodsFor: '*People-spfa-utils' stamp: 'spfa 3/13/2004 10:18'!
provider: anObject
	provider _ anObject! !

!SPFATextMorphEditor methodsFor: 'as yet unclassified' stamp: 'spfa 5/16/2003 13:40'!
ptm

	^ morph owner owner! !

!MenuMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 4/9/2004 15:19'!
queryArgumentFor: aSelector inBehalfOf: anObject withString: aString initialAnswer: stringOrSymbol then: cSelector

	| str |

	aSelector ifNil: [^ self].

	str _ FillInTheBlank request: aString 
			initialAnswer: 
				(stringOrSymbol isSymbol 
					ifTrue: [(anObject perform: stringOrSymbol) asSetterString] 					ifFalse: [stringOrSymbol]) .
	str ifEmpty: [^ self].

	anObject perform: aSelector withArguments: {Compiler evaluate: str}.
	defaultTarget perform: cSelector 
! !

!Utilities class methodsFor: '*People-spfa-utils' stamp: 'spfa 6/3/2004 13:46'!
queryValue: aString proposed: aDefault format: aSymbol

	"ask the user for the new value of aDefault.
	aSymbol is sent to the resulting string 
	when the string is empty, it defaults to aDefault

	ex: 
		Utilities queryValue: 'number:' proposed: 42 format: #asInteger
		Utilities queryValue: 'your name ?' proposed: '' format: #asString
		Utilities queryValue: 'expression:' proposed: '25+45' format: #evaluate
	"

	^ ((FillInTheBlank request: aString
 				 			initialAnswer: (aDefault asString)) 
		whenEmpty: [aDefault asString]) perform: aSymbol! !

!Utilities class methodsFor: '*People-spfa-utils' stamp: 'spfa 6/3/2004 13:45'!
queryValue: aString proposed: aDefault format: aSymbol ifNoAnswer: aBlock

	"ask the user for the new value of aDefault.
	aSymbol is sent to the resulting string 
	except when the string is empty: aBlock value is then returned

	ex: 
		Utilities queryValue: 'number:' proposed: 42 format: #asInteger
		Utilities queryValue: 'your name ?' proposed: '' format: #asString
		Utilities queryValue: 'expression:' proposed: '25+45' format: #evaluate
	"

	^ ((FillInTheBlank request: aString
 				 			initialAnswer: (aDefault asString)) 
		whenEmpty: [^ aBlock value]) perform: aSymbol! !

!Point class methodsFor: '*People-spfa-utils' stamp: 'spfa 3/28/2003 23:04'!
r: rho theta: theta
	"Answer an instance of me with polar coordinates rho and theta."

	^self new setR: rho radians: theta! !

!Number methodsFor: '*People-spfa-utils' stamp: 'spfa 12/2/2003 21:37'!
radiansToMIDI: angle

	^ (self scaleFromAngle: angle to: (0 to: 127)) rounded! !

!MouseInputArea methodsFor: 'accessing' stamp: 'spfa 3/11/2004 09:15'!
receiver: anObject selector: aSelector

	messageSend _ MessageSend receiver: anObject selector: aSelector! !

!MessageTally class methodsFor: '*People-spfa-utils' stamp: 'spfa 6/1/2004 19:29'!
reportSpyOn: aBlock 
	| node report |
	node _ self new.
	node spyEvery: self defaultPollPeriod on: aBlock.
	report _ node tally isZero 
				ifTrue:[''] 
				ifFalse: [String streamContents: [:s | node report: s; close]].
	^ report! !

!LineSegment methodsFor: '*People-spfa-utils' stamp: 'spfa 5/6/2003 23:24'!
rotatedBy: angle about: center

	^ self class from: (start copy rotateBy: angle about: center)
				 to: (end copy rotateBy: angle about: center)! !

!MGraphWorkspace methodsFor: 'as yet unclassified' stamp: 'spfa 5/16/2003 15:31'!
saveContentsInFile

	(self dependents detect: [:o | o isMemberOf: SystemWindow]) saveOnFile
! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 6/17/2003 14:50'!
saveOnFileRememberWhere

	| aFileName fileStream ok |

	(self hasProperty: #lastFileNameWhenSaved)
		ifTrue: [aFileName _ self valueOfProperty: #lastFileNameWhenSaved]
		ifFalse: [aFileName _ ('my ', self class name) asFileName].

	aFileName _ FillInTheBlank request: 'File name? (".morph" will be added to end)' 
			initialAnswer: aFileName.
	aFileName size == 0 ifTrue: [^ self].

	self allMorphsDo: [:m | m prepareToBeSaved].

	ok _ aFileName endsWith: '.morph'.	"don't double them"
	ok _ ok | (aFileName endsWith: '.sp').
	ok ifFalse: [aFileName _ aFileName,'.morph'].

	self setProperty: #lastFileNameWhenSaved toValue: aFileName.

	fileStream _ FileStream newFileNamed: aFileName.
	fileStream fileOutClass: nil andObject: self.	"Puts UniClass definitions out anyway"! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 5/14/2004 20:57'!
saveOnUsualFile

	|  fileStream |

	(self hasProperty: #lastFileNameWhenSaved)
		ifFalse: [^ self saveOnFileRememberWhere].
	
	self allMorphsDo: [:m | m prepareToBeSaved].

	fileStream _ FileStream newFileNamed: 
						(self valueOfProperty: #lastFileNameWhenSaved).
	fileStream fileOutClass: nil andObject: self.! !

!Number methodsFor: '*People-spfa-utils' stamp: 'spfa 12/2/2003 21:16'!
scaleFrom: anInterval to: anotherInterval

	^ (anotherInterval extent * ((self forceIn: anInterval) - anInterval first) / anInterval extent) + anotherInterval first! !

!Number methodsFor: '*People-spfa-utils' stamp: 'spfa 12/2/2003 21:32'!
scaleFromAngle: aNumber to: anInterval

	| intv |

	intv _ aNumber to: (aNumber + Float twoPi).

	^ (self moduleIn: intv) scaleFrom: intv to: anInterval! !

!SPFATextMorphEditor methodsFor: 'as yet unclassified' stamp: 'spfa 1/26/2004 18:36'!
selectionAsEvaluableString

	^ (model bindEmbeddedMorphsIn: (paragraph text 
												copyFrom: stopBlock stringIndex 
												to: startBlock stringIndex -1))
	asString withBlanksCondensed! !

!SPFATextMorphEditor methodsFor: 'as yet unclassified' stamp: 'spfa 5/16/2003 14:46'!
selectionAsStream
	"Answer a ReadStream on the text in the paragraph that is currently 
	selected."

	| str |

	str _ self selectionAsEvaluableString..

	^ReadWriteStream
		on: str 
		from: 1
		to: str size! !

!SimpleServiceEntry methodsFor: '*People-spfa-utils' stamp: 'spfa 3/13/2004 10:18'!
selector: aSelector
	selector _ aSelector! !

!DropReporter class methodsFor: 'as yet unclassified' stamp: 'spfa 3/11/2004 09:42'!
sendMorphTo: anObject via: aSelector

	^ self new receiver: anObject selector: aSelector! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 4/7/2003 18:03'!
setProperty: aSymbol toValue: anObject then: bSymbol

	self setProperty: aSymbol
		  toValue: anObject.

	self perform: bSymbol
					! !

!Point methodsFor: '*People-spfa-utils' stamp: 'spfa 3/28/2003 23:03'!
setR: rho radians: radians 

	x _ rho asFloat * radians cos.
	y _ rho asFloat * radians sin.! !

!SPFAPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'spfa 5/14/2003 14:07'!
setText: aText
	scrollBar setValue: 0.0.
	textMorph
		ifNil: [textMorph _ SPFATextMorphForEditView new
						contents: aText wrappedTo: self innerBounds width-6.
				textMorph setEditView: self.
				scroller addMorph: textMorph]
		ifNotNil: [textMorph newContents: aText].
	self hasUnacceptedEdits: false.
	self setScrollDeltas.! !

!MouseInputArea methodsFor: 'private' stamp: 'spfa 3/11/2004 09:15'!
smallLabel: aString

	self removeAllMorphs.
	self addMorph: ((TextMorph new contents: aString) 
						borderWidth: 0;
						margins: 1;
						centered;
						autoFit: true;
						backgroundColor: Color transparent; 
						center: bounds center;
						bottom: bounds bottom)! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 2/6/2004 14:23'!
smallThumbnailForPageSorter

	^ (BookPageThumbnailMorph new smaller) page: self! !

!MouseInputArea methodsFor: 'stepping' stamp: 'spfa 3/11/2004 09:15'!
step

	(self temporary
		and: [Time now >= (1.5 seconds + (self valueOfProperty: #creationTime))])
		ifTrue: [self delete]
		
! !

!MouseInputArea methodsFor: 'stepping' stamp: 'spfa 3/11/2004 09:15'!
stepTime

	^ 100
		
! !

!MGraphWorkspace methodsFor: 'SHOUT' stamp: 'spfa 5/14/2004 19:16'!
stylerAboutToStyle: aTextStyler

	"disable SHOUT styling in MGraph Workspaces"

	^ false.
	
! !

!String methodsFor: '*People-spfa-utils' stamp: 'spfa 11/10/2003 14:40'!
surroundedByDoubleQuotes
	"Answer the receiver with leading and trailing quotes.  "

	^ $" asString, self, $" asString! !

!Class methodsFor: '*People-spfa-utils' stamp: 'spfa 5/20/2003 15:32'!
symbol

	^ self asString asSymbol! !

!MouseInputArea methodsFor: 'testing' stamp: 'spfa 3/11/2004 09:15'!
temporary

	^ self hasProperty: #temporary.
	
	! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 2/6/2004 14:23'!
thumbnailForPageSorter

	^ (BookPageThumbnailMorph new) page: self! !

!Integer methodsFor: '*People-spfa-utils' stamp: 'spfa 4/1/2003 15:33'!
timesRepeatWithIndex: aBlock 
	"Evaluate the argument, aBlock, the number of times represented by the 
	receiver."

	| count |
	count _ 1.
	[count <= self]
		whileTrue: 
			[aBlock value: count.
			count _ count + 1]! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 1/11/2003 16:46'!
toggleProperty: aSymbol

	self setProperty: aSymbol
		  toValue: ((self hasProperty: aSymbol) not)
					! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 4/1/2003 16:18'!
toggleProperty: aSymbol then: bSymbol

	self setProperty: aSymbol
		  toValue: ((self hasProperty: aSymbol) not).

	self perform: bSymbol
					! !

!Float class methodsFor: '*People-spfa-utils' stamp: 'spfa 5/31/2003 15:49'!
twoPi

	^ Twopi! !

!Float class methodsFor: '*People-spfa-utils' stamp: 'spfa 3/23/2004 14:39'!
twoPiPer: aNumber

	^ Twopi / aNumber! !

!Rectangle class methodsFor: '*People-spfa-utils' stamp: 'spfa 5/7/2003 14:02'!
unit

	^ (0@0) corner: (1@1)! !

!MGraphWorkspace methodsFor: 'as yet unclassified' stamp: 'spfa 1/26/2004 20:24'!
value

	^ (self bindingOf: 'value') value ifNil: [Silence new]! !

!String methodsFor: '*People-spfa-utils' stamp: 'spfa 3/5/2003 15:04'!
value: v

	"ugly hack allowing the replacement of BlockContext by String in some cases, which makes it possible to serialize objects expecting a BlockContext as instance variable"

	^ (Compiler evaluate: self) value: v! !

!MessageSend methodsFor: '*People-spfa-utils' stamp: 'spfa 2/19/2004 15:39'!
valuePerform: aSelector 

	^ self value perform: aSelector ! !

!MessageSend methodsFor: '*People-spfa-utils' stamp: 'spfa 2/19/2004 15:39'!
valuePerform: aSelector withArguments: anArray

	^ self value perform: aSelector withArguments: anArray! !

!MouseInputArea methodsFor: 'copying' stamp: 'spfa 4/9/2004 14:38'!
veryDeepFixupWith: deepCopier

	super veryDeepFixupWith: deepCopier.
	messageSend _ deepCopier references at: messageSend ifAbsent: [messageSend].! !

!MouseInputArea methodsFor: 'copying' stamp: 'spfa 4/9/2004 14:41'!
veryDeepInner: deepCopier

	super veryDeepInner: deepCopier.
	balloonText _ balloonText veryDeepCopyWith: deepCopier.
	messageSend _ messageSend.! !

!DropReporter methodsFor: 'event handling' stamp: 'spfa 5/8/2003 15:33'!
wantsDroppedMorph: dropee event: evt

	^ true
		
! !

!MGraphWorkspace methodsFor: 'as yet unclassified' stamp: 'spfa 5/22/2003 15:36'!
wantsDroppedMorph: dropee event: evt inMorph: target

	^ acceptDroppedMorphs 
		and: [dropee isKindOf: MGraphElementMorph orOf: MGraphVignette]! !

!SPFAPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'spfa 5/16/2003 14:49'!
watchIt
	| result sm |
	self handleEdit:
		[result _ textMorph editor compileSelectionAsBlock.
		((result isKindOf: FakeClassPool) or: [result == #failedDoit])
			ifTrue: [^self flash]].
	sm _ (RectangleMorph new)
		layoutPolicy: TableLayout new;
		layoutInset: 3;
		listDirection: #topToBottom;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		addMorphBack: (StringMorph contents: textMorph editor selectionAsEvaluableString);
		addMorphBack: ((UpdatingStringMorph on: result selector: #value)
			stepTime: 500;
			maximumWidth: nil;
			growable: true);
		color: Color white;
		borderColor: Color black;
		openInWorld;
		yourself.
	self currentHand attachMorph: sm.

! !

!Collection methodsFor: '*People-spfa-utils' stamp: 'spfa 1/26/2004 20:17'!
whenEmpty: aBlock

	^ self isEmpty ifTrue: aBlock ifFalse: [self]! !

!Rectangle methodsFor: '*People-spfa-utils' stamp: 'spfa 1/24/2003 09:43'!
width: aNumber

	^ self origin corner: (self origin x + aNumber) @ self corner y! !

!MessageSend methodsFor: '*People-spfa-utils' stamp: 'spfa 3/13/2004 10:47'!
withMetaSelector: aSelector

	^ MessageSend 
		receiver: self 
		selector: #valuePerform:
		arguments: {aSelector}! !

!MessageSend methodsFor: '*People-spfa-utils' stamp: 'spfa 3/13/2004 11:15'!
withMetaSelector: aSelector arguments: anArray

	^ MessageSend 
		receiver: self 
		selector: #valuePerform:withArguments:
		arguments: {aSelector . anArray}! !

!Number methodsFor: '*People-spfa-utils' stamp: 'spfa 5/28/2003 18:38'!
x

	"consistent with the usual graphic representation of imaginary numbers"

	^ self! !

!Number methodsFor: '*People-spfa-utils' stamp: 'spfa 5/28/2003 18:38'!
y

	"consistent with the usual graphic representation of imaginary numbers"

	^ 0! !

!Boolean methodsFor: '*People-spfa-utils' stamp: 'spfa 1/11/2003 16:41'!
yesNoString

	self subclassResponsibility! !

!False methodsFor: '*People-spfa-utils' stamp: 'spfa 1/11/2003 16:42'!
yesNoString

	^ '<no>'! !

!True methodsFor: '*People-spfa-utils' stamp: 'spfa 1/11/2003 16:42'!
yesNoString

	^ '<yes>'! !

!SPFATextMorphEditor methodsFor: 'as yet unclassified' stamp: 'spfa 5/16/2003 14:12'!
zapSelectionWith: aText

	| morphs | 

	morphs _ self text embeddedMorphsFrom: startBlock stringIndex to: stopBlock stringIndex.
	super zapSelectionWith: aText.

	morphs do: [:m | m delete]! !
